function UIManager() 
{
	// sanity check : we should never treat the same WPT id twice, so we keep a list of the ones we've looked at and show error if we do get one twice 
	this.treatedWPTIDs = [];
	this.scatterPlotData =[];
	this.boxPlotData =[];
	this.finegrainedLogging = false; // TODO: make toggle-able from the UI! (then, we need a full redraw as well of course )
	
	this.selectedMetrics = ["loadEventEnd", "SpeedIndex"];//, "fullyLoaded"]; // "visualComplete"]; //, "TTFB"];
	this.controlSubcaseName = "h2o_http2_sched_prio_aware";
	this.selectedTestrunSubset = [];
	this.selectedTestrunSubsetInverse = [];
	this.maxPValue = 0.005;
	
	this.latexTable_simple = "";
	this.latexTable_http1s = "";
	this.latexTable_advanced = "";
	
	this._oneWptDataPerTestrun = {}; // used for getting CDF data for testrun page sizes and request counts (not in our normal dataset, this serves as a caching layer)
	this.wptQueriesSent = 0;
	this.wptQueriesReceived = 0;
	
	this.shortSubcaseNames = {};
	this.shortSubcaseNames["h2o_http2_sched_fcfs"] = "\\fcfs";
	this.shortSubcaseNames["h2o_http2_sched_prio_aware"] = "prio aware"; 
	this.shortSubcaseNames["h2o_http2_sched_rr"] = "\\rr";
	this.shortSubcaseNames["h2o_http2_priorities_chrome_parallelism"] = "parallel";//"chrome parallel";
	this.shortSubcaseNames["h2o_http2_priorities_chrome_parallelism_advanced"] = "parallel+";//"chrome parallel+";
	this.shortSubcaseNames["h2o_http2_priorities_firefox_serialization"] = "serial";//"ff serialized";
	this.shortSubcaseNames["h2o_http2_priorities_firefox_serialization_advanced"] = "serial+";//"ff serialized+";
	this.shortSubcaseNames["h2o_http1s"] = "\\hsoneone"; 
	
	$("#toggleAllDetailsButton").click(function(evt)
	{
		//$("input[name='toggleDetailBox']").trigger("click");
		
		//$("input[name='toggleDetailBox']")[0].click();
		$("input[name='toggleDetailBox']").click();
	});
	
	
	
	$("#toggleAllGraphsButton").click(function(evt) 
	{
		$(".CDF").toggle();
		$(".boxplot").toggle();
	});
	
	$("#toggleAllTablesButton").click(function(evt)
	{
		$(".results-table").toggle();
	});
	
	
	
	$("#deleteWPTCache").click(function(evt) 
	{
		data.WPTDataCache.DeleteStoredData();
		alert("WPT cache cleared! Reload to start fetching the values anew");
	});
	
	$("input[name='metric-selector']").click( function(evt)
	{
		console.log("Metric selected : " + evt.target.value);
		
		var metricBoxes = $("input[name='metric-selector']:checked");
	
		var selectedValues = [];
		for( var b = 0; b < metricBoxes.length; ++b )
		{
			var box = $(metricBoxes[b]);
			selectedValues.push( box.val() );
		}
		
		if( selectedValues.length == 0 )
			selectedValues.push( "loadEventEnd" );
		
		ui.selectedMetrics = selectedValues;
		
		$("#content").html( "" );
		setTimeout(function()
		{
			ui.VisualizeMannWhitney( data.dataRoot );
		}, 200); // give page time to clear 
	
	});
	
	$("#controlSubcase-selector").change( function(evt)
	{
		var selectedSubcase = $('#controlSubcase-selector option:selected').val();
		
		console.log("Subcase control group selected : " + selectedSubcase);
		
		ui.controlSubcaseName = selectedSubcase;
		
		$("#content").html( "" );
		setTimeout(function()
		{
			ui.VisualizeMannWhitney( data.dataRoot );
		}, 200); // give page time to clear 
	});
	
	$("#maxPValue-selector").change( function(evt)
	{
		var selectedPValue = $('#maxPValue-selector option:selected').val();
		
		if( selectedPValue == "point5-percent" )
			selectedPValue = 0.005;
		else
			selectedPValue = 0.05;
		
		console.log("Max p value selected : " + selectedPValue);
		
		ui.maxPValue = selectedPValue;
		
		$("#content").html( "" );
		setTimeout(function()
		{
			ui.VisualizeMannWhitney( data.dataRoot );
		}, 200); // give page time to clear 
	});
	
	$("#testrunSubset-selector").change( function(evt)
	{
		var selectedSubset = $('#testrunSubset-selector option:selected').val();
		
		console.log("Subset selected : " + selectedSubset);
		
		// NOTE: only the main testrun names are needed, http1s should be picked up automatically
			
		var subset = [];
		var inverseSubset = [];
		
		if( (selectedSubset == "conext2017_pageweight_low") || 
			(selectedSubset == "conext2017_pageweight_low+") ||
			(selectedSubset == "conext2017_pageweight_low23may") || 
			(selectedSubset == "conext2017_pageweight_low+23may") )
		{
			// (weight < 600 KB) OR ((# resources < 10) && (weight < 1000 KB))
			subset.push("H2priorities_pilot_test_realistic_facebook_2");
			subset.push("H2priorities_pilot_test_realistic_google_3");
			//subset.push("H2priorities_pilot_test_realistic_msn"); // MSN was manually found to be an "anomaly" in this taxonomy category
			subset.push("H2priorities_pilot_test_realistic_w3");
			subset.push("H2priorities_pilot_test_realistic_wikipedia_3");
			subset.push("H2priorities_pilot_test_realistic_wordpress_2"); 
            
			if( (selectedSubset == "conext2017_pageweight_low") || 
				(selectedSubset == "conext2017_pageweight_low+"))
			{
				subset.push("H2priorities_pilot_test_realistic_gnu");
				subset.push("H2priorities_pilot_test_realistic_apache");
				subset.push("H2priorities_pilot_test_realistic_opera");
				subset.push("H2priorities_pilot_test_realistic_gravatar");
				subset.push("H2priorities_pilot_test_realistic_phpbb");
			}
			
			if( (selectedSubset == "conext2017_pageweight_low+") ||
				(selectedSubset == "conext2017_pageweight_low+23may") )
			{
				// weight < 1000 KB
				subset.push("H2priorities_pilot_test_realistic_bitly");
				subset.push("H2priorities_pilot_test_realistic_dotdash");
				subset.push("H2priorities_pilot_test_realistic_govuk");
				subset.push("H2priorities_pilot_test_realistic_reddit");
				subset.push("H2priorities_pilot_test_realistic_statcounter");
				
//				if( selectedSubset == "conext2017_pageweight_low+" )
//				{
//				}
			}
		}
		else if( (selectedSubset == "conext2017_pageweight_medhigh") ||
				 (selectedSubset == "conext2017_pageweight_medhigh23may") )
		{
			// everything > 1000 KB
			subset.push("H2priorities_pilot_test_realistic_canvas");
			subset.push("H2priorities_pilot_test_realistic_cnet_3");
			subset.push("H2priorities_pilot_test_realistic_demorgen");
			subset.push("H2priorities_pilot_test_realistic_etsy");
			subset.push("H2priorities_pilot_test_realistic_github");
			subset.push("H2priorities_pilot_test_realistic_harvard");
			subset.push("H2priorities_pilot_test_realistic_imdb_2");
			subset.push("H2priorities_pilot_test_realistic_imgur");
			subset.push("H2priorities_pilot_test_realistic_nytimes");
			subset.push("H2priorities_pilot_test_realistic_telegraph_3");
			subset.push("H2priorities_pilot_test_synthetic_test-wpo-extended");
			subset.push("H2priorities_pilot_test_realistic_vodlib");
			subset.push("H2priorities_pilot_test_realistic_vtm");
			subset.push("H2priorities_pilot_test_realistic_youtube_2");
			
			if( selectedSubset == "conext2017_pageweight_medhigh" )
			{
				subset.push("H2priorities_pilot_test_realistic_pinterest");
				subset.push("H2priorities_pilot_test_realistic_joomla");
				subset.push("H2priorities_pilot_test_realistic_academia_2");
				subset.push("H2priorities_pilot_test_realistic_sciencemag2");
				subset.push("H2priorities_pilot_test_realistic_researchgate");
				subset.push("H2priorities_pilot_test_realistic_intel2");
			}
		}
		else if( selectedSubset == "syntheticOnly" ) // there is no syntheticOnly23may because we added no synthetic websites for 1jun
		{
			subset.push("H2priorities_pilot_test_synthetic_test-wpo-extended");
		}
		else if( selectedSubset == "realisticOnly" )
		{
			inverseSubset.push("H2priorities_pilot_test_synthetic_test-wpo-extended");
		}
		else if( selectedSubset == "realisticOnly23may" || selectedSubset == "all23may" )
		{
			if( selectedSubset != "all23may" )
				inverseSubset.push("H2priorities_pilot_test_synthetic_test-wpo-extended");
			
			// at jun1, several sites were added. To get the 23 may state back, we need to remove those new sites from the list, using the inverted logic:
			inverseSubset.push("H2priorities_pilot_test_realistic_academia_2");
			inverseSubset.push("H2priorities_pilot_test_realistic_apache");
			inverseSubset.push("H2priorities_pilot_test_realistic_gnu");
			inverseSubset.push("H2priorities_pilot_test_realistic_gravatar");
			inverseSubset.push("H2priorities_pilot_test_realistic_intel2");
			inverseSubset.push("H2priorities_pilot_test_realistic_joomla");
			inverseSubset.push("H2priorities_pilot_test_realistic_opera");
			inverseSubset.push("H2priorities_pilot_test_realistic_pinterest");
			inverseSubset.push("H2priorities_pilot_test_realistic_phpbb");
			inverseSubset.push("H2priorities_pilot_test_realistic_researchgate");
			inverseSubset.push("H2priorities_pilot_test_realistic_sciencemag2");
		}
		else
		{
			console.log("Subset ALL selected, selectedTestrunSubset will be empty array!");
		}
		
		ui.selectedTestrunSubset = subset;
		ui.selectedTestrunSubsetInverse = inverseSubset;
		
		$("#content").html( "" );
		setTimeout(function()
		{
			ui.VisualizeMannWhitney( data.dataRoot );
		}, 200); // give page time to clear 
	});
	
	
	$("#exportToJSONButton").click(function(evt) 
	{
		console.log("Exporting ", data.dataRoot);
		
		// our data contains circular references to data, which isn't something normal JSON can deal with 
		// so we use an algorithm to replace the circular pointers to strings in JSON-PATH format which can later be rebuilt when loading the json 
		// see cycle.js for the implementation 
		var currentDataDecycled = JSON.decycle(data.dataRoot);
		var jsonCurrentData = JSON.stringify(currentDataDecycled);
		jsonCurrentData = "var full_data = " + jsonCurrentData + ";";
		
		var fileNameToSaveAs = "full_data.js";
		ui._downloadString( fileNameToSaveAs, jsonCurrentData );
	});
	
	$("#downloadCDFtestrunSizes").click(function(evt) 
	{
		alert("This functionality is not available in this offline version, since it requires access to our internal servers").
		return;
		
		var self = ui;
		
		var generateCDF = function()
		{
			console.log("About to generate CDF sizes!");
			
			var testrunNames = [];
			var measurementsX = [];
			for( var testrunName of Object.keys(self._oneWptDataPerTestrun) )
			{
				
				var wptResult = self._oneWptDataPerTestrun[testrunName];
				var measurementX = wptResult.data.median.firstView.bytesIn;
				
				measurementsX.push( measurementX );
				testrunNames.push( { name: testrunName, xValue : measurementX } );
			}
			
			testrunNames.sort( function(a,b){ return a.xValue - b.xValue; } );
			measurementsX.sort( function(a, b){ return a - b; } );
			
			var Y = [];
			for( var i = 0; i < measurementsX.length; ++i )
			{
				Y[i] = (i + 1) / measurementsX.length;
			}
			
			var data = [{ label: "pageSize", dataX : measurementsX, dataY : Y, testruns : testrunNames }];
			
			var fileNameToSaveAs = "CDF.pageSize.json";
			var jsonData = "{ \"data\" : " + JSON.stringify(data, null, '\t') + "}";
			
			ui._downloadString( fileNameToSaveAs, jsonData );
		};
		
		if( Object.keys(self._oneWptDataPerTestrun).length == 0 )
		{
			self._FillWPTDataPerTestrun(generateCDF);
		}
		else
			generateCDF();
		
	});
	
	
	$("#downloadCDFtestrunRequests").click(function(evt) 
	{
		alert("This functionality is not available in this offline version, since it requires access to our internal servers").
		return;
		
		var self = ui;
		
		var generateCDF = function()
		{
			console.log("About to generate CDF sizes!");
			
			var testrunNames = [];
			var measurementsX = [];
			for( var testrunName of Object.keys(self._oneWptDataPerTestrun) )
			{
				
				var wptResult = self._oneWptDataPerTestrun[testrunName];
				var measurementX = wptResult.data.median.firstView.requests;
				
				measurementsX.push( measurementX );
				testrunNames.push( { name: testrunName, xValue : measurementX } );
			}
			
			testrunNames.sort( function(a,b){ return a.xValue - b.xValue; } );
			measurementsX.sort( function(a, b){ return a - b; } );
			
			var Y = [];
			for( var i = 0; i < measurementsX.length; ++i )
			{
				Y[i] = (i + 1) / measurementsX.length;
			}
			
			var data = [{ label: "requestCount", dataX : measurementsX, dataY : Y, testruns : testrunNames }];
			
			var fileNameToSaveAs = "CDF.requestCount.json";
			var jsonData = "{ \"data\" : " + JSON.stringify(data, null, '\t') + "}";
			
			ui._downloadString( fileNameToSaveAs, jsonData );
		};
		
		if( Object.keys(self._oneWptDataPerTestrun).length == 0 )
		{
			self._FillWPTDataPerTestrun(generateCDF);
		}
		else
			generateCDF();
		
	});
	
};

UIManager.prototype._FillWPTDataPerTestrun = function(callback)
{
	var self = this;
	self.wptQueriesSent = 0;
	self.wptQueriesReceived = 0;
	
	for( var value of data.dataRoot.values ) 
	{
	
		//if( self.wptQueriesSent > 5 ) // FIXME: REMOVE!
		//	continue;
		
		(function(value){
		
			var testrunIndex = value[0].indexOf("testrun");
			
			var testrun = value[testrunIndex];
			
			if( Object.keys(self._oneWptDataPerTestrun).indexOf(testrun) >= 0 )
			{
				// we already have data for this testrun, skip it!
				return;
			}
			else
				self._oneWptDataPerTestrun[ testrun ] = "busy fetching"; // occupy this key so it can be filled later 
		
			
			
			var externalIDindex = value[0].indexOf("externalID"); 
			var externalID = value[externalIDindex];
			
			// during exporting, we came across some testruns that don't have valid data 
			// it's easier to just hardcode them here than deal with this properly (since we would have to search another value of the correct testrun to try again later)
			// since this function is only used for some additional CDFs, this is easier and faster
			// Note: the mann-whitney test has ALL the WPT data, so it can pick the ones that don't have erroneous results 
			if( externalID == "170530_MD_4c7f61b87c065c96022549333b9dc98c" || // first gnu result
				externalID == "170530_QK_f248c51211a9631a0321076b82ba34f2" || // another erroneus gnu result 
				externalID == "170518_9P_b93df9308ff8d3a7be9c06e334f4fc4e" ) // first wikipedia result
			{
				delete self._oneWptDataPerTestrun[ testrun ];
				return;
			}
			
			self.wptQueriesSent += 1;
			
			data.WPTDataCache.FetchRemoteDataFor( externalID, function(result)
			{
				self.wptQueriesReceived += 1;
				
				console.log("WPT data fetched for " + testrun, self.wptQueriesReceived, self.wptQueriesSent);
				 
				
				if( result && result.data && result.statusCode == 200 )
				{
					self._oneWptDataPerTestrun[testrun] = result;
					
					// sanity check 
					if( externalID != result.data.id )
					{
						console.error("UIManager:_FillWPTDataPerTestrun : fetched data is for wrong ID! ", externalID, result );
					}
					
					console.log("WPTData received : ", testrun, result);
				}
				else
					console.error("UIManager:_FillWPTDataPerTestrun : erroneous result", result, testrun);
				
				
				if( self.wptQueriesSent == self.wptQueriesReceived )
				{	
					console.log("one wpt result per testrun : ", self._oneWptDataPerTestrun);
					
					// we're all done, we can call the callback!
					callback(undefined);
				}
			});
		
		})(value);// wrap in function so we can bring value into the inner scope (by default, it stays in the global for-loop scope and is overridden)
	}
	
};

// TODO: move to utils 
UIManager.prototype._downloadString = function(suggestedFilename, dataString)
{
	var textFileAsBlob = new Blob([dataString], {
		type: 'text/plain'
	});
	var fileNameToSaveAs = suggestedFilename;

	var downloadLink = document.createElement("a");
	downloadLink.download = fileNameToSaveAs;
	downloadLink.innerHTML = "Export File";
	if (window.webkitURL != null) {
		// Chrome allows the link to be clicked
		// without actually adding it to the DOM.
		downloadLink.href = window.webkitURL.createObjectURL(textFileAsBlob);
	} else {
		// Firefox requires the link to be added to the DOM
		// before it can be clicked.
		downloadLink.href = window.URL.createObjectURL(textFileAsBlob);
		downloadLink.onclick = destroyClickedElement;
		downloadLink.style.display = "none";
		document.body.appendChild(downloadLink);
	}

	downloadLink.click();
};

UIManager.prototype.toggleDetail = function(elem)
{
	// we are in a td, so go up to that, then the tr, then the next tr is the one we need to toggle
	$(elem).parent().parent().next().toggle();
};

UIManager.prototype.downloadCDFData = function(cdfID, elem)
{
	var self = this;
	console.log("DOWNLOADING " + cdfID + " data");
	
	var foundScatterPlot = undefined;
	for( var scatterPlot of self.scatterPlotData )
	{
		if( scatterPlot.id == cdfID ) 
		{
			foundScatterPlot = scatterPlot;
			break;
		}
	}
	
	if( !foundScatterPlot )
	{
		alert("Data not found for id " + cdfID);
		return;
	}
	
	console.log("Saving scatterplot ", foundScatterPlot);
	
	var value = foundScatterPlot.splitSeries[0];
	var fileNameToSaveAs = "CDF." + value.traffic + "." + value.frontend + "." + value.metric + ".json";
	var jsonData = "{ \"data\" : " + JSON.stringify(foundScatterPlot.splitSeries, null, '\t') + "}";
	
	ui._downloadString( fileNameToSaveAs, jsonData );
};

UIManager.prototype.VisualizeMannWhitney = function( hierarchicalData )
{
	var self = this;
	self.scatterPlotData = [];
	self.boxPlotData = [];
	self.treatedWPTIDs = [];
	
	
	$("#content").html( "" ); // clear any existing contents 
	
	// helper functions to more easily get the correct data nodes we need 
	var _FindNodeWithTag = function( root, tag )
	{
		if( root.tag != tag )
		{
			var length = Object.keys(root.children).length;
			if( length == 0 )
			{
				return undefined;
			}
			
			for( var child of Object.keys(root.children) )
			{
				return _FindNodeWithTag( root.children[child], tag );
			}
		}
		else
		{
			return root;
		}
	};
	
	
	var htmlString = "";
	
	// we assume this order in the hierarchicalData:["testcase", "traffic", "metric", "frontend", "testrun", "subcase" ];
	var trafficRoot = _FindNodeWithTag(hierarchicalData, "traffic");
	if( !trafficRoot )
	{
		console.error("UIManager:VisualizeMannWhitney : no traffic root found! ", hierarchicalData);
		return;
	}
	
	var flatList = [];
	
	var trafficNames = Object.keys(trafficRoot.children);
	trafficNames.sort(function(a,b)
	{
		var sortOrder = [];
		sortOrder["cable_40ms"] = 100;
		sortOrder["cellular_noloss"] = 99;
		sortOrder["cellular_good"] = 98;
		sortOrder["cellular_fair"] = 97;
		sortOrder["cellular_poor"] = 96;
		
		return sortOrder[b] - sortOrder[a];
	});
	
	for( var trafficName of trafficNames )
	{
		if( trafficName == "cellular_verypoor")
			continue;
		
		var traffic = trafficRoot.children[trafficName];
		htmlString += '<h2>' + trafficName + '</h2>';
		htmlString += '<div class="trafficContainer">';
		
		// metric is a special case, since we use the WPT data directly 
		// so the metric in our Oracle exports are probably just loadEventEnd, since we get the rest from WPT data 
		// so in this flow, we hardcode the wanted metrics ourselves 
		
		
		var metrics = self.selectedMetrics;
		
		for( var metricName of metrics )
		{
			htmlString += '<h3>' + metricName + '</h3>';
			htmlString += '<div style="width: 100%;">';
			
			var frontendRoot = _FindNodeWithTag(traffic, "frontend");
			
			for( var frontendName of Object.keys(frontendRoot.children) )
			{
				var frontend = frontendRoot.children[frontendName];
				htmlString += '<div class="frontendContainer"><strong>' + frontendName + '</strong><br/>';
				
				var subcaseBuckets = [];
				
				var testrunRoot = _FindNodeWithTag(frontend, "testrun");
				
				// for each testrun, we need to compare values between each and the prio_aware and give a single (P) value per combination
				// these then have to be aggregated in buckets of speedup percentages
				// indicate how many maybe, not just % (Because we only have 25 sites, percentages will be skewed no matter what? )
				
				
				var controlSubcaseName = self.controlSubcaseName; //"h2o_http2_sched_prio_aware";
				
				if( controlSubcaseName == "browserSimple" )
				{
					if( frontendName.indexOf("chrome") >= 0 )
						controlSubcaseName = "h2o_http2_priorities_chrome_parallelism";
					else if( frontendName.indexOf("firefox") >= 0 )
						controlSubcaseName = "h2o_http2_priorities_firefox_serialization";
				}
				else if( controlSubcaseName == "browserAdvanced" )
				{
					if( frontendName.indexOf("chrome") >= 0 )
						controlSubcaseName = "h2o_http2_priorities_chrome_parallelism_advanced";
					else if( frontendName.indexOf("firefox") >= 0 )
						controlSubcaseName = "h2o_http2_priorities_firefox_serialization_advanced";
				}
				
				for( var testrunName of Object.keys(testrunRoot.children) )
				{
					// .length is 0 if ALL testruns are ok OR inverted logic is used (see next if-test)
					// else, the testrunName has to be in the subset to be accepted 
					if( self.selectedTestrunSubset.length != 0 && self.selectedTestrunSubset.indexOf(testrunName) < 0 )
						continue;
					
					// sometimes it's easier to set the testruns that should NOT be accepted, which is inverse logic, hence: selectedTestrunSubsetInverse
					if( self.selectedTestrunSubsetInverse.length != 0 && self.selectedTestrunSubsetInverse.indexOf(testrunName) >= 0 )
						continue;
					
					var testrun = testrunRoot.children[testrunName];
					//htmlString += '<p><u>' + testrunName + '</u> (total count: '+ Object.keys(testrunRoot.children).length +')</p>';
					
					//console.error("Mann whitney " + testrunName + " @ " + frontend + " @ " + metricName + " @ " + traffic);
					var mwResults = self._MannWhitneyForTestrun( testrun, metricName, controlSubcaseName ); 
					
					var subcaseNames = Object.keys(mwResults);
					for( var subcaseName of subcaseNames )
					{
						if( !subcaseBuckets[subcaseName] )
						{
							subcaseBuckets[subcaseName] = [];
						}
						
						mwResults[subcaseName].testrunName = testrunName;
						mwResults[subcaseName].testrun = testrun;
						
						subcaseBuckets[subcaseName].push( mwResults[subcaseName] );
					}
					
					//htmlString += '<p>' + JSON.stringify( mwResults ) + '</p>'; 
					
					// sanity check 
					// make sure the hierarchical data is correctly grouped!
					for( var subcaseName of Object.keys(testrun.children) )
					{
						for( var value of testrun.children[subcaseName].values )
						{
							var valueSubcase 	= value[ value[0].indexOf("subcase") ];
							var valueTestrun 	= value[ value[0].indexOf("testrun") ];
							var valueFrontend 	= value[ value[0].indexOf("frontend") ];
							var valueMetric 	= value[ value[0].indexOf("metric") ];
							var valueTraffic 	= value[ value[0].indexOf("traffic") ];
							
							if( valueSubcase != subcaseName || valueTestrun != testrunName || valueFrontend != frontendName || metrics.indexOf(valueMetric) < 0 || valueTraffic != trafficName )
							{
								console.error("UIManager:VisualizeMannWhitney : values wrongly grouped! ", value, subcaseName, testrunName, valueFrontend, metrics, valueTraffic, trafficRoot);
								//alert("UIManager:VisualizeMannWhitney : values wrongly grouped!");
							}
						}
					}
					
				}
			
				
				// now we have all results grouped by subcase in subcaseBuckets and need to generate improvementBuckets from those 
				// i.e. we now have the ROWS (subcase), need to group to get COLUMNS (% of improvement)
				
						
				var _CreateResultsTable = function(subcaseBuckets, controlSubcaseName, improvementToChoose)
				{
					var output = "";
					
					output += "<p>Control group: " + controlSubcaseName + "</p>";
					output += '<table class="results-table" border="1">';
					output += '<tr>';
					output += '<th>Priority algo</th>';
					output += '<th>#websites/<br/>#values</th>';
					output += '<th>No change</th>';
					output += '<th class="improvement">+any</th>';
					output += '<th class="improvement">&ge; +5%</th>';
					output += '<th class="improvement">&ge; +10%</th>';
					output += '<th class="improvement">&ge; +25%</th>';
					output += '<th class="degradation">-any</th>';
					output += '<th class="degradation">&ge; -5%</th>';
					output += '<th class="degradation">&ge; -10%</th>';
					output += '<th class="degradation">&ge; -25%</th>';
					output += '</tr>';
					
					
					var subcaseBucketKeys = Object.keys(subcaseBuckets);
					subcaseBucketKeys.sort();
				
					for( var subcaseName of subcaseBucketKeys ) 
					{
						if( subcaseName == controlSubcaseName ) // not showing in the table, because has no significant differences on itself of course 
							continue;
						
						output += '<tr>';
						
						var subcaseValues = subcaseBuckets[subcaseName];
						//console.log( "Results for " + subcaseName, subcaseValues );
						
						var buckets = [];
						buckets["none"] = [];
						buckets["+any"] = [];
						buckets["+5"] = [];
						buckets["+10"] = [];
						buckets["+25"] = [];
						buckets["-any"] = [];
						buckets["-5"] = [];
						buckets["-10"] = [];
						buckets["-25"] = [];
						buckets["valueCount"] = 0;
						
						var improvements = [];
						for( var value of subcaseValues )
						{
							var improvement = value[improvementToChoose];
							improvements.push( improvement );
							if( improvement > 0 )
							{
								buckets["+any"].push(value);
								
								if( improvement > 0.05 )
									buckets["+5"].push(value);
								if( improvement > 0.10 )
									buckets["+10"].push(value);
								if( improvement > 0.25 )
									buckets["+25"].push(value);
							}
							else if( improvement < 0 )
							{
								buckets["-any"].push(value);
								
								if( improvement < -0.05 )
									buckets["-5"].push(value);
								if( improvement < -0.10 )
									buckets["-10"].push(value);
								if( improvement < -0.25 )
									buckets["-25"].push(value);
							}
							else
								buckets["none"].push( improvement );
							
							buckets["valueCount"] += value.measurements.length;
						}
						
						buckets["allCount"] = improvements.length;
						
						subcaseValues.groupedBuckets = buckets;
						
						function improvedCSS(amountOfValues)
						{
							var style = "";
							var opacity = amountOfValues * 0.2;
							if( amountOfValues > 0 )
								style += "background-color: rgba(0,255,0,"+ opacity +");";
							
							//if( opacity > 0.8 )
							//	style += "color: white;"
							
							return style;
						}
						
						function degradedCSS(amountOfValues)
						{
							var style = "";
							var opacity = amountOfValues * 0.2;
							if( amountOfValues > 0 )
								style += "background-color: rgba(255,0,0,"+ opacity +");";
							
							if( opacity > 0.6 )
								style += "color: white;"
							
							return style;
						}
						
						
						var detailCheckbox = '<input type="checkbox" name="toggleDetailBox" onclick="ui.toggleDetail(this)" />';
						
						output += '<td>' + detailCheckbox + ' '+ ui.shortSubcaseNames[subcaseName] 	+'</td>';
						output += '<td>'+ subcaseValues.length 		+' / '+ buckets["valueCount"] +'</td>';
						output += '<td>'+ buckets["none"].length 	+'</td>';
						output += '<td style="'+ improvedCSS( buckets["+any"].length ) 	+'">'+ buckets["+any"].length 	+'</td>';
						output += '<td style="'+ improvedCSS( buckets["+5"].length )	+'">'+ buckets["+5"].length 	+'</td>';
						output += '<td style="'+ improvedCSS( buckets["+10"].length ) 	+'">'+ buckets["+10"].length 	+'</td>';
						output += '<td style="'+ improvedCSS( buckets["+25"].length ) 	+'">'+ buckets["+25"].length 	+'</td>';
						output += '<td style="'+ degradedCSS( buckets["-any"].length ) 	+'">'+ buckets["-any"].length 	+'</td>';
						output += '<td style="'+ degradedCSS( buckets["-5"].length ) 	+'">'+ buckets["-5"].length 	+'</td>';
						output += '<td style="'+ degradedCSS( buckets["-10"].length ) 	+'">'+ buckets["-10"].length 	+'</td>';
						output += '<td style="'+ degradedCSS( buckets["-25"].length ) 	+'">'+ buckets["-25"].length 	+'</td>';
						
						output += '</tr>';
						
						var improvementDetails = [];
						for( var value of subcaseValues )
						{
							var improvement = value[improvementToChoose];
							
							if( improvement != 0 )
							{
								improvementDetails.push(value);
							}
						}
						
						// from good to bad improvement 
						improvementDetails.sort( function(a,b){ return b[improvementToChoose] - a[improvementToChoose]; } );
						
						output += '<tr style="display: none;"><td colspan="11">'; 
						for( var improvementDetail of improvementDetails )
						{
							var percentage = improvementDetail[improvementToChoose]; // is now a number between [-1,1]
							percentage *= 100;
							percentage = Math.round(percentage);
							
							var style = "display: inline-block;padding: 5px;";
							var colorScale = Math.floor(Math.abs(percentage) / 10);
							if( percentage < 0 )
								style += degradedCSS( colorScale );
							else 
								style += improvedCSS( colorScale );
							
							// want a link for all subcases here, so we can easily click through to compare to control group for example 
							// we use .testrun to get to all the subcases (siblings of the current one)
							var wptLinks = [];
							for( var subcaseName of Object.keys(improvementDetail.testrun.children) )
							{
								var subcase = improvementDetail.testrun.children[ subcaseName ];
									
								for( var value of subcase.values )
								{
									var wptLink = "LOCAL_WebpagetestInstance_URL" + value[ value[0].indexOf("externalID") ];
									
									wptLinks.push( { name: ui.shortSubcaseNames[subcaseName], wptLink: wptLink} );
								}
							}
							
							var wptLinkOutput = "";
							for( var wptLink of wptLinks )
							{
								wptLinkOutput += '<a href="'+wptLink.wptLink+'" target="_blank">'+wptLink.name+'</a>, ';
							}
							
							
							output += '<span style="'+style+'">' + percentage + "% : " + improvementDetail.testrunName + ' ' + wptLinkOutput +'</span>' + '<br/>';
						}
						output += '</td></tr>';
					}
					
					output += '</table>';
					
					return output;
				};	
					
				htmlString += _CreateResultsTable( subcaseBuckets, controlSubcaseName, "medianImprovement" ); // presumably correct version : small p IS ok 
				
				
				var subcaseBucketKeys = Object.keys(subcaseBuckets);
				subcaseBucketKeys.sort();
				for( var subcaseName of subcaseBucketKeys ) 
				{
					var subcase = subcaseBuckets[subcaseName];
					
					if( !subcase.groupedBuckets ) // is the case for the controlSubcase
						continue;
					
					var flatValue = {};
					flatValue.values = subcase.groupedBuckets;
					flatValue.traffic = trafficName;
					flatValue.metric = metricName;
					flatValue.frontend = frontendName;
					flatValue.subcase = subcaseName; 
					
					flatList.push( flatValue );
				}
				
				var _CreateCDFGraph = function(subcaseBuckets)
				{
					var output = ""
					
					var scatterPlot = {};
					scatterPlot.series = [];
					scatterPlot.splitSeries = [];
					
					var subcaseBucketKeys = Object.keys(subcaseBuckets);
					subcaseBucketKeys.sort();
					for( var subcaseName of subcaseBucketKeys ) // fcfs, rr, prio_aware, etc.
					{
						var subcaseValues = subcaseBuckets[subcaseName];
						
						var allMeasurements = [];
						for( var subcaseValue of subcaseValues ) // what was returned from MannWhitney (.medianImprovement, .significantP etc.)
						{
							var measurements = subcaseValue.measurements.slice(); // copy of the actual used raw data 
							allMeasurements = allMeasurements.concat( measurements );
						}
						
						
						// now we need to draw a line for allMeasurements 
						// a) sort values from low to high 
						// b) for each value, take 1-based-index/total-nr-of-values (e.g. 1/100 for 100 datapoints) = percentagepoints 
						// c) use percentagePoints as Y, sorted list as X
						
						allMeasurements.sort( function(a, b){ return a - b; } );
						var Y = [];
						for( var i = 0; i < allMeasurements.length; ++i )
						{
							Y[i] = (i + 1) / allMeasurements.length;
						}
						
						// flot expects data in form [x1, y1], so we need to re-combine the data 
						var serie = [];
						for( var i = 0; i < allMeasurements.length; ++i )
						{
							serie.push( [allMeasurements[i], Y[i]] );
						}
		
						
						var label = ui.shortSubcaseNames[subcaseName];
						scatterPlot.series.push( 		{ label: label, metric : metricName, data: serie} );
						scatterPlot.splitSeries.push( 	{ subcase: label, metric : metricName, traffic : trafficName, frontend: frontendName, dataX: allMeasurements, dataY: Y} );
					}
					
					function _RandomID()
					{
						var text = "";
						var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

						for( var i=0; i < 10; i++ )
							text += possible.charAt(Math.floor(Math.random() * possible.length));

						return text;
					}
						
					
					scatterPlot.id = _RandomID();
					scatterPlot.title = "THE SCATTERPLOT TITLE, TODO";
					 
					var downloadButton = '<button id="'+scatterPlot.id+'_download" type="button" onclick="ui.downloadCDFData(\''+scatterPlot.id+'\',this);"> download JSON data </button>';
					output += '<div class="CDFcontainer" style="float: left; margin: 5px;"><div class="CDF" id="'+ scatterPlot.id +'" style="width: 400px; height: 300px;"></div>'+ downloadButton +'</div>';
					
					
					self.scatterPlotData.push( scatterPlot );
					
					
					//console.log("All measurements", subcaseMeasurementBuckets);
					
					return output;
				};
				
					
				function _CreateBoxplotGraph()
				{
					
					var output = ""
					
					var boxPlot = {};
					boxPlot.series = [];
					
					boxPlot.medians = [];
					boxPlot.minmax  = [];
					boxPlot.means   = [];
					
					var currentX = 0;
					
					var subcaseBucketKeys = Object.keys(subcaseBuckets);
					subcaseBucketKeys.sort();
					for( var subcaseName of subcaseBucketKeys ) // fcfs, rr, prio_aware, etc.
					{
						// each bar is a separate series, otherwhise no different labels... 
						var subcaseMedians = [];
						
						var subcaseValues = subcaseBuckets[subcaseName];
						
						var allMeasurements = [];
						for( var subcaseValue of subcaseValues ) // what was returned from MannWhitney (.medianImprovement, .significantP etc.)
						{
							var measurements = subcaseValue.measurements.slice(); // copy of the actual used raw data 
							allMeasurements = allMeasurements.concat( measurements );
						}
						
						
						// now we need to calculate percentiles and min/max for each value 
						var stats = new Stats();
						stats.push( allMeasurements );
						
						var median = stats.median();
						var range = stats.range();
						var min = range[0];
						var max = range[1];
						var mean = stats.amean();
						
						subcaseMedians.push([currentX, median]);
						boxPlot.minmax.push([currentX, median, median - min, max - median]);
						boxPlot.means.push([currentX, mean]);
						
						var label = ui.shortSubcaseNames[subcaseName];
						boxPlot.medians.push( { label: label, data: subcaseMedians, bars: { show: true, barWidth: 1, align: "center" } } );
						
						currentX++;
						currentX++;
					}
					
					
					var minMaxSerie = {};
					minMaxSerie.color = "black";
					minMaxSerie.points = { radius: 0, errorbars: "y", yerr: { show:true, upperCap: "-", lowerCap: "-", asymmetric: true, radius: 5}};
					minMaxSerie.data = boxPlot.minmax;
					
					var meanSerie = {};
					meanSerie.color = "black";
					meanSerie.points = { show: true, radius: 3};
					meanSerie.data = boxPlot.means ;
					
					var series = boxPlot.medians.slice(0);
					series.push( minMaxSerie );
					series.push( meanSerie );
	
					boxPlot.series = series;
					
					
					function _RandomID()
					{
						var text = "";
						var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

						for( var i=0; i < 10; i++ )
							text += possible.charAt(Math.floor(Math.random() * possible.length));

						return text;
					}
						
					boxPlot.id = _RandomID();
					boxPlot.title = "THE BOXPLOT TITLE, TODO";
					output += '<div class="boxplot" id="'+ boxPlot.id +'" style="float: left;width: 400px; height: 300px; margin: 5px;"></div>';
					
					self.boxPlotData.push( boxPlot );
					
					return output;
				}
				
				htmlString += '<div>';
				htmlString += _CreateCDFGraph( subcaseBuckets );
				htmlString += _CreateBoxplotGraph( subcaseBuckets );
				htmlString += '</div><div style="clear: both;"></div>';
				
				//htmlString += '<div class="reverseLogicImprovementsContainer"><br/><strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;TOM BERGAN LOGIC:</strong><br/>';
				//htmlString += _CreateResultsTable( subcaseBuckets, "medianImprovementReverseLogic" ); // Tom Bergan version, small p IS NOT ok 
				//htmlString += '</div>'; // frontendContainer
				
					
				htmlString += '</div>'; // frontendContainer
			}
			htmlString += '</div><div style="clear: both;"></div>';
		}
		
		htmlString += '</div>' // trafficContainer
	}
	
	var _createLatexTable = function( flatList, caption, label, includeFrontends, includeMetrics, includeSubcases, includeTraffic )
	{
		var output = "";
		
		// the latex table follows a wholly different pecking order than we use in the main .html visualisation
		// main .html: traffic -> metric -> frontend -> subcase 
		// latex: 	   frontend -> metric -> subcase -> traffic
		
		// as such, we need to re-arrange
		// we add all values to a flat array while building the HTML output
		// this means we can now re-group them into a hierarchical tree-structure (very similar to what we get from the Oracle export)
		
		var tagOrder = ["frontend", "metric", "subcase", "traffic"];
		var dataRoot = {};
		dataRoot.values = flatList;
		dataRoot.parent = {};
		dataRoot.parent.tag = "";
		dataRoot.parentTagValue = "";
		
		var _sortRawValuesRecursive = function( root, tags )
		{		
			//console.log( "sorting results : " + JSON.stringify(tags) + " -> from " + root.parentTagValue, root);
			
			var currentTag = tags.shift();
			root.tag = currentTag;
			root.children = {};

			for( var value of root.values )
			{
				var tagValue = value[currentTag]; // e.g. value.metric 
				if( !root.children[tagValue] )
				{
					var newRoot = {};
					newRoot.children = {};
					newRoot.values = [];
					newRoot.parent = root;
					newRoot.parentTagValue = tagValue;
					
					root.children[tagValue] = newRoot;
				}
				
				root.children[tagValue].values.push( value );
			}
			
			if( tags.length <= 0 )
				return;
			
			for( var child of Object.keys(root.children) )
			{
				_sortRawValuesRecursive( root.children[child], tags.slice() );
			}
		};

		_sortRawValuesRecursive( dataRoot, tagOrder.slice() ); // make tree, slice the tagOrder since it's being changed in sortRawValuesRecursive
		
		// step 2: we now have the sorted list, so we need to start outputting latex code! 
		
		
		output += String.raw`\begin{table*}[]` + '\n';
		output += String.raw`\centering` + '\n';
		output += String.raw`\caption{${caption}}` + '\n';
		output += String.raw`\label{${label}}` + '\n';
		output += String.raw`\small` + '\n';
		output += String.raw`\begin{tabular}{ll|l|cc|cc||l|cc|cc||l|cc|cc|}` + '\n';
		output += String.raw`\cline{3-17}` + '\n';
		output += String.raw`	& \multicolumn{1}{c|}{} & \multicolumn{5}{c||}{\nccable network} & \multicolumn{5}{c||}{\ncgood cellular network} & \multicolumn{5}{c|}{\ncpoor cellular network} \\ \cline{3-17} `;
		output += String.raw` &                       &      & \multicolumn{2}{c|}{speedup} & \multicolumn{2}{c||}{slowdown} &       & \multicolumn{2}{c|}{speedup} & \multicolumn{2}{c||}{slowdown} &       & \multicolumn{2}{c|}{speedup} & \multicolumn{2}{c|}{slowdown} \\ \cline{3-17} ` + '\n';
		//output += String.raw`\multicolumn{1}{l|}{setting} & case            & 0\%  & +5\%         & +25\%         & -5\%          & -25\%         & 0\%   & +5\%         & +25\%         & -5\%          & -25\%         & 0\%   & +5\%         & +25\%         & -5\%          & -25\%         \\ \hline` + '\n';
		output += String.raw`\multicolumn{1}{l|}{setting} & case            & 0\%  & $\geqslant$5\%         & $\geqslant$25\%         & $\geqslant$5\%          & $\geqslant$25\%         & 0\%   & $\geqslant$5\%         & $\geqslant$25\%         & $\geqslant$5\%          & $\geqslant$25\%         & 0\%   & $\geqslant$5\%         & $\geqslant$25\%         & $\geqslant$5\%          & $\geqslant$25\%         \\ \hline` + '\n';
		
		
		
		// we assume the correct tag-order here ["frontend", "metric", "subcase", "traffic"]
		for( var frontendName of Object.keys(dataRoot.children) )
		{
			var frontend = dataRoot.children[frontendName];
			
			if( includeFrontends.length > 0 && includeFrontends.indexOf(frontend) < 0 )
				continue;
				
			for( var metricName of Object.keys(frontend.children) )
			{
				var metric = frontend.children[metricName];
				
				if( includeMetrics.length > 0 && includeMetrics.indexOf(metricName) < 0 )
					continue;
					
				var metricChanged = true;
				
				for( var subcaseName of Object.keys(metric.children) )
				{
					var subcase = metric.children[subcaseName];
					
					
					if( includeSubcases.length > 0 && includeSubcases.indexOf(subcaseName) < 0 )
						continue;
						
					// making sure traffic always has the same sequence
					var trafficNames = Object.keys(subcase.children);
					trafficNames.sort(function(a,b)
					{
						var sortOrder = [];
						sortOrder["cable_40ms"] = 100;
						sortOrder["cellular_noloss"] = 99;
						sortOrder["cellular_good"] = 98;
						sortOrder["cellular_fair"] = 97;
						sortOrder["cellular_poor"] = 96;
						
						return sortOrder[b] - sortOrder[a];
					});
					
					if( metricChanged )
					{
						var shortFrontendNames = [];
						shortFrontendNames["wpt_chrome"] = "Chrome";
						shortFrontendNames["wpt_firefox"] = "Firefox";
						
						var shortMetricNames = [];
						shortMetricNames["loadEventEnd"] = "\\metricLEE";
						shortMetricNames["SpeedIndex"] = "\\metricSI";
						
						
						if( includeSubcases && includeSubcases.length > 1 )
							output += String.raw`\hline \multicolumn{1}{l|}{\multirow{ 2}{*}{\begin{tabular}[c]{@{}l@{}}${shortFrontendNames[frontendName]},\\ {\footnotesize ${shortMetricNames[metricName]}} \end{tabular}}}  & ${ui.shortSubcaseNames[subcaseName]} & `;
						else
							output += String.raw`\hline \multicolumn{1}{l|}{\begin{tabular}[c]{@{}l@{}}${shortFrontendNames[frontendName]},\\ ${shortMetricNames[metricName]} \end{tabular}}  & ${ui.shortSubcaseNames[subcaseName]} & `;
						
					}
					else
					{
						output += String.raw`\multicolumn{1}{l|}{}                                                                			 & ${ui.shortSubcaseNames[subcaseName]} & `;
					}
					
					var first = true;
					for( var trafficName of trafficNames )
					{
						var traffic = subcase.children[trafficName];
						
						if( includeTraffic.length > 0 && includeTraffic.indexOf(trafficName) < 0 )
							continue;
						
						var value = traffic.values[0].values; // the groupedBuckets 
						// sanity check
						if( traffic.values.length > 1 )
							console.error("UIManager:_createLatexTable : more than 1 value! shouldn't happen! ", traffic, dataRoot);
						
						if( !first )
							output += ' & ';
						
						output += '' + value["none"].length + ' & ' + value["+5"].length + ' & ' + value["+25"].length + ' & ' + value["-5"].length + ' & ' + value["-25"].length;
						
						first = false;
					}
					
					output += String.raw`\\`;
					output += '\n';
				
					
					metricChanged = false;
				}
			}
		}
		
		
		output += String.raw`\hline`;
		output += String.raw`\end{tabular}`;
		output += String.raw`\end{table*}`;
		
		return output;
		
	};
	
	// frontend, metrics, subcases, traffic 
	var N = flatList[0].values["allCount"];
	
	ui.latexTable_simple   = _createLatexTable( flatList, "Priority-aware versus priority-agnostic \\htwo (n = "+N+") (baseline = priority-aware \\htwo)", "table_prioritiesSimple", [], [], ["h2o_http2_sched_fcfs", "h2o_http2_sched_rr"], ["cable_40ms", "cellular_good", "cellular_poor"] );
	ui.latexTable_http1s   = _createLatexTable( flatList, "\\hsoneone versus \\htwo (n = "+N+") (baseline = priority-aware \\htwo) (LEE = \\metricLEE, SI = \\metricSI)", "table_prioritiesHttp1s", [], [], ["h2o_http1s"], ["cable_40ms", "cellular_good", "cellular_poor"] );
	ui.latexTable_advanced = _createLatexTable( flatList, "\\htwo prioritization tampering at server-side (n = "+N+") (baseline = priority-aware \\htwo)", "table_prioritiesAdvanced", [], [], ["h2o_http2_priorities_chrome_parallelism","h2o_http2_priorities_chrome_parallelism_advanced","h2o_http2_priorities_firefox_serialization","h2o_http2_priorities_firefox_serialization_advanced"], ["cable_40ms", "cellular_good", "cellular_poor"] );
	
	$("#textualOutput_tableSimple").val( ui.latexTable_simple );
	$("#textualOutput_tableHTTP1s").val( ui.latexTable_http1s );
	$("#textualOutput_tableAdvanced").val( ui.latexTable_advanced );
	
	
	$("#content").html( htmlString );
	
	
	for( var scatterPlot of self.scatterPlotData )
	{
		$.plot("#" + scatterPlot.id, scatterPlot.series, 
		{
			xaxis: { max: 10000, min: 0 }, 
			yaxis : { max: 1.05, min: 0, tickSize: 0.1 },
			//zoom: { interactive: true },
			pan: { interactive: true },
			legend: { show: true, position: "se", margin: [0, 0], noColumns: 1}, 
			grid: {margin: 25, hoverable: true, clickable: true}
		});
	}
	
	for( var boxPlot of self.boxPlotData )
	{
		$.plot("#" + boxPlot.id, boxPlot.series, 
		{
			xaxis: { ticks: [], autoscaleMargin: 0.02 }, 
			//yaxis : { max: yMax, ticks : yTicks, panRange: [0, yMax + 10000] }, 
			yaxis : { max: 5000 },
			series: { lines:{ show: false } },
			zoom: { interactive: true },
			pan: { interactive: true },
			legend: { show: true, position: "ne", margin: [-120, 0], noColumns: 1},
			grid: {margin: 25, hoverable: true, clickable: true}
		});
	}
};

// TODO: possibly move this to DataManager? Or separate helper class? 
UIManager.prototype._MannWhitneyForTestrun = function( testrun, metricName, controlSubcaseName )
{
	
	// Our subcases of the testrun are basically different priority-schemes
	// for example, subcase "prio_aware" is the default browser behaviour, subcase "fcfs" is first-come-first-serve, "rr" is round-robin etc.
	// we want to know the improvements (or degradations) these different priority schemes bring when compared to the default browser behaviour 
	// for this, we use the Mann-Whitney U-test (https://en.wikipedia.org/wiki/Mann%E2%80%93Whitney_U_test)
	// this is a well-established statistical test and our data adheres to it's preconditions
	// it was also used in a similar study by Tom Bergan (https://docs.google.com/document/d/1oLhNg1skaWD4_DtaoCxdSRN5erEXrH-KnLrMwEpOtFY/edit)
	
	// we first find the controlCase (the default browser behaviour) -> the passed in "controlSubcaseName" variable 
	// after this, we compare these control values to the other subcase values
	// we use 2 different implementations of the mann-whitney test and do plenty of sanity checks to be sure our results are correct 
	// for each subcase, we return the "relative improvement" value (as output.medianImprovement) for that subcase to the controlSubcase 
	// this relative improvement is in % : -0.1 means this subcase is 10% slower than the control case. +0.5 means this subcase is 50% faster than the control case. 
	
	var self = this;
	var output = {};
	
	
	var _FindNodeWithParentTagValue = function( root, parentTagValue )
	{
		if( root.parentTagValue != parentTagValue )
		{
			var length = Object.keys(root.children).length;
			if( length == 0 )
				return undefined;
			
			for( var child of Object.keys(root.children) )
			{
				return _FindNodeWithParentTagValue( root.children[child], parentTagValue );
			}
		}
		else
			return root;
	};
	
	var _ExtractWPTMeasurements = function(wptData, metricName)
	{
		var output = [];
		
		var measurementIndices = Object.keys(wptData.runs);
		for( var measurementIndex of measurementIndices )
		{
			output.push( wptData.runs[ measurementIndex ].firstView[ metricName ] );
		}
		
		// sometimes we have an undefined value, which will mess with our calculations, so we remove it here 
		// http://stackoverflow.com/questions/9882284/looping-through-array-and-removing-items-without-breaking-for-loop
		var amountDropped = 0;
		var originalOutputLength = output.length;
		for( var i = output.length - 1; i >= 0; --i )
		{
			if( !output[i] || output[i] === undefined )
			{
				output.splice(i,1);
				amountDropped++;
				//console.warn("UIManager:_ExtractWPTMeasurements : had to remove a value due to undefined ", originalOutputLength, output.length, i, metricName, wptData);
			}
		}
		
		if( self.finegrainedLogging )
		{
			if( amountDropped > 2 )
			{
				console.error("UIManager:_ExtractWPTMeasurements : had to drop more than 2 measurements : " + amountDropped + "", output.length, i, metricName, wptData);
			}
		}
		else
		{
			if( amountDropped > 5 )
			{
				console.error("UIManager:_ExtractWPTMeasurements : had to drop more than 5 measurements : " + amountDropped + "", output.length, i, metricName, wptData);
			}
		}
		
		return output;
	};
	
	var _CalculateMedian = function(samples)
	{
		samples = samples.slice(); // copy array, don't want sort() to re-arrange original one in-place 
		
		samples.sort(function(a, b) {
			return a - b;
		});
		
		var median = undefined;
		
		// http://www.alcula.com/calculators/statistics/median/
		if( samples.length % 2 == 0 )
		{
			// even amount of samples, need to interpolate
			var leftIndex  = ((samples.length) / 2) - 1; // -1 because index is 0-based
			var rightIndex = ((samples.length + 2) / 2) - 1;  // -1 because index is 0-based
			var median = ( samples[leftIndex] + samples[rightIndex] ) / 2;
			//console.log("MEDIAN ", median, leftIndex, rightIndex, samples.length);
		}
		else
		{
			// odd amount of samples, just use the center one 
			var medianIndex = ((samples.length + 1) / 2) - 1; // = Math.ceil( samples.length / 2 ) - 1 // -1 because index is 0-based
			median = samples[medianIndex];
			//console.log("MEDIAN ", median, medianIndex, samples.length);
		}
		
		return Math.ceil(median);
	};
	
	// need to make sure our controlSubcase is treated first 
	var subcaseNamesOrdered = [];
	subcaseNamesOrdered.push( controlSubcaseName );
	for( var subcaseName of Object.keys(testrun.children))
	{
		if( subcaseName != controlSubcaseName )
			subcaseNamesOrdered.push( subcaseName );
	}
	
	var controlSubcaseRoot = _FindNodeWithParentTagValue( testrun, controlSubcaseName );
	// TODO: extract WPT values for controlCase
	
	// TODO: toch controlCse ook behandelen in normale loop, gewoon zorgen dat hij eerst zit
	// -> pak Object.keys, remove controlcase, voeg in begin toe, loop dan 
	
	var controlMeasurements = undefined;
	
	for( var subcaseName of subcaseNamesOrdered )
	{
		var subcase = testrun.children[subcaseName];
		
		//console.log("Calculating values for " + testrun.parentTagValue + " @ " + metricName + " -> " + subcase.parentTagValue, subcase );
		
		var value = subcase.values[0];
		
		// it is possible that we have multiple values for a single measurement 
		// this happens when a test is run twice (or more) for the same parameters 
		// usually, the first run was erroneous or has no results, so we want to make sure not to take that one!
		// so here, we search the most likely candidate that has correct values
		if( subcase.values.length != 1 )
		{
			var chosenIndex = -1;
			for( var i = 0; i < subcase.values.length; ++i )
			{
				var testValue = subcase.values[i];
				var columnNames = testValue[0];
				var max = testValue[ columnNames.indexOf("max") ];
				var median = testValue[ columnNames.indexOf("median") ];
				var sum = testValue[ columnNames.indexOf("sum") ];
				
				if( median == 0 || max == 0 || sum == 0 )
				{
					// erroneous value, go and try the next one 
				}
				else
				{
					chosenIndex = i;
					break;
				}
			}
			if( chosenIndex != -1 )
			{
				value = subcase.values[ chosenIndex ];
				
				// it is known wikipedia has 2 valid values for some of its runs, so ignore that here 
				//if( chosenIndex == 0 && value[ value[0].indexOf("testrun") ].indexOf("wikipedia") < 0 )
				//{
					if( self.finegrainedLogging )
						console.warn("UIManager:_MannWhitneyForTestrun : multiple values! trying to choose the correct one : " + i, subcase.values, value);
					else
					{
						if( subcase.values.length > 2 ) // in our testdata, all had max of 2 values 
						{
							console.warn("UIManager:_MannWhitneyForTestrun : more than 2 values! trying to choose the correct one : " + i, subcase.values, value);
						}
					}
				//}
			}
			else
				value = undefined;
		}
		
		if( !value )
		{
			console.error("UIManager:_MannWhitneyForTestrun : No correct value found for measurement, skipping!", testrun, metricName);
			continue;
		}
		
		var wptData = value[ value.length - 1 ].wptData.data;
		//console.log( wptData );
		
		// sanity check 
		if( self.treatedWPTIDs.indexOf(wptData.id) >= 0 )
		{
			console.error("UIManager:_MannWhitneyForTestrun : WPT id was already used! ", testrun, subcase, value, wptData);
		}
		else
		{
			self.treatedWPTIDs[ wptData.id ] = true;
		}
		
		
		// now we have an aggregated value, but we still need to extract all the independent values from the WPT data
		var measurements = _ExtractWPTMeasurements( wptData, metricName );
		
		// we always want to compare to one group which is the control group / baseline
		// i.e. given the control group, we want ot know if this subcase is better or worse in the median case 
		// in our examples, the controlgroup is basically the default browser implementation of the priorities (prio_aware) and we compare our custom versions to this "factual implementation"
		if( subcaseName == controlSubcaseName)
		{
			controlMeasurements = measurements;
			controlMedian = _CalculateMedian( controlMeasurements );
			
			if( self.finegrainedLogging )
			{
				if( controlMeasurements.length < 19 )
				{
					console.error("UIManager:_MannWhitneyForTestrun : Control measurements do not have at least 19 samples! could be problematic! " + controlMeasurements.length, testrun, subcaseName, metricName, controlMeasurements, measurements);
						
				}
			}
			else
			{
				if( controlMeasurements.length < 15 )
				{
					console.error("UIManager:_MannWhitneyForTestrun : Control measurements do not have at least 15 samples! could be problematic! " + controlMeasurements.length, testrun, subcaseName, metricName, controlMeasurements, measurements);
						
				}
			}
		}
		//else // let's also calculate everything for the control group. If we see significant differences for itself, we know something is not right! 
		//{
			if( !controlMeasurements )
			{
				console.error("UIManager:_MannWhitneyForTestrun : ControlMeasurements not set... cannot perform mann-whitney! ", subcaseName);
				continue;
			}
			
			// sanity check 
			// https://stats.stackexchange.com/questions/40342/mann-whitney-u-test-with-unequal-sample-sizes
			// we CAN use mann-Whitney on different sample sizes, BUT not if they become too big
			// for this test, we define too big as > 10%. We have 20 samples for most tests, so 10% is 2 samples. So as soon as we get 17 or less, the difference is too large 
			if( controlMeasurements.length != measurements.length )
			{
				var ninetyPercent = Math.round( 0.9 * controlMeasurements.length );
				if( measurements.length < ninetyPercent )
				{
					console.error("UIManager:_MannWhitneyForTestrun : not the same amount of measurements between control case and test case! Difference is larger than 10% " + controlMeasurements.length + " != " + measurements.length, testrun, subcaseName, metricName, controlMeasurements, measurements);
					continue;
				}
			}
			
			// we are inspired by the approach used by Tom Bergan in similar experiments 
			// https://docs.google.com/document/d/1oLhNg1skaWD4_DtaoCxdSRN5erEXrH-KnLrMwEpOtFY/edit
			// NOTE: we have to swap the relative-improvement section from the original text, because we believe it to be wrongfully explained there 
			// see our discussion of p-values below 
			// let A = the 20 samples from group A
			// let B = the 20 samples from group B (control)
			// let p = p value from the two-tailed Mann-Whitney U test on A and B 
			//relative improvement = 1 - median(A)/median(B)   if p < 0.005
			//						 0                         otherwise
			
			
			// we use 2 independent implementations of mann-whitney to make sure we don't suffer from implementation errors of peculiarities
			// see the individual implementation files for more information
			
			var results1 = MannWhitney1.test( measurements, controlMeasurements );
			var samples2 = [measurements, controlMeasurements];
			var results2 = MannWhitney2.test( samples2 );
			
			// results1 is an object: { U : value, p : value, significantU : boolean}
			// results2 is an array: [ U1, U2 ]
			// the results1.U is the minimum of the 2 U values of the two-tailed test
			// we need to calculate the p-value of the 2nd implementation ourselves here 
			
			var u2 = Math.min( results2[0], results2[1] );
			var z2 = MannWhitney2.criticalValue(results2, samples2);
			var p2 = MannWhitney1.dnorm( -z2, 0, 1 ) * 2; // implementation 2 doesn't have a separate function for this, we can re-use the one from implementation 1 
			var significant2 = MannWhitney2.significant(results2, samples2); // significance in the U value, not the p value (just for checking assumptions later)
			var check2 = MannWhitney2.check(results2, samples2);
			
			results2 = {};
			results2.U = u2;
			results2.p = p2;
			results2.significantU = significant2;
			results2.checked = check2;
			
			// sanity check 
			if( !results2.checked )
			{
				console.error("UIManager:_MannWhitneyForTestrun : impl2.check() doesn't return true! ", controlMeasurements, measurements, subcase);
			}
		
			
			
			
			
			// https://en.wikipedia.org/wiki/P-value
			// "The smaller the p-value, the larger the significance because it tells the investigator that the null hypothesis under consideration may not adequately explain the observation" (so small p-value = hypothesis is rejected)
			// https://en.wikipedia.org/wiki/Mann%E2%80%93Whitney_U_test
			// for the mann-whitney test, the null hypothesis is "that it is equally likely that a randomly selected value from one sample will be less than or greater than a randomly selected value from a second sample"
			// in other words: if this null hypothesis is rejected, it is NOT equally likely that a value from one sample will be less/greater than the second sample 
			// in other words: if this null hypothesis is rejected, it is MORE likely that there is a larger chance that the sample will be less/greater consistenly 
			// see also http://blog.minitab.com/blog/understanding-statistics/what-can-you-say-when-your-p-value-is-greater-than-005
			// see also https://www.isixsigma.com/tools-templates/hypothesis-testing/making-sense-mann-whitney-test-median-comparison/
			results1.significantP = results1.p < ui.maxPValue;//0.005;  
			results2.significantP = results2.p < ui.maxPValue;//0.005;  
			
			 
			// sanity check
			// happened in about 5% of our testdata 
			// TODO: look up why this matters and if the calculation is correct 
			// and why MannWhitney2 calculates it this way... can't find anything directly for their formula online 
			if( results2.significantU != results2.significantP || results1.significantU != results1.significantP  )
			{
				//console.error("UIManager:_MannWhitneyForTestrun : significance for P and U not the same ", results1, results2, controlMeasurements, measurements);
			}
			
			
			
			if( subcaseName == controlSubcaseName)
			{
				// sanity check
				// comparing the control group to itself, shouldn't have any differences obv!
				// we saw this happen in testdata if all measurements were exactly the same value (i.e. 20 samples of value 41 for TTFB for both control and non-control data)
				// for some reason, impl1 gives a very high p-value and impl2 gives 0 as p-value 
				if( results1.significantP || results1.significantU || results2.significantP || results2.significantU )
				{
					var allTheSameValue = true;
					var originalValue = controlMeasurements[0];
					for( var i = 1; i < controlMeasurements.length; ++i )
					{
						if( controlMeasurements[i] != originalValue )
							allTheSameValue = false;
					}
					
					if( !allTheSameValue )
						console.error("UIManager:_MannWhitneyForTestrun : Controlgroup is significantly different from itself?!?!!? ", results1, results2, controlMeasurements, value);
				}
			}
			else
			{
				// see above
				var allTheSameValue = true;
				var originalValue = controlMeasurements[0];
				for( var i = 1; i < controlMeasurements.length; ++i ) 
				{
					if( controlMeasurements[i] != originalValue )
						allTheSameValue = false;
				}
					
				// sanity check 
				// didn't happen in our test data 
				if( results1.significantU != results2.significantU )
				{
					if( !allTheSameValue )
						console.error("UIManager:_MannWhitneyForTestrun : disagreement on significant U ", results1, results2, controlMeasurements, measurements);
				}
				
				// sanity check
				// didn't happen in our test data 
				if( results1.significantP != results2.significantP )
				{
					if( !allTheSameValue )
						console.error("UIManager:_MannWhitneyForTestrun : disagreement on significant P ", metricName, results1, results2, controlMeasurements, measurements);
					
					// if they don't agree, just assume it is NOT significant!
					results1.significantP = results2.significantP = false; 
				}
				
				
				var errorOnU = false;
				if( results1.U != results2.U )
				{
					errorOnU = true;
					if( !allTheSameValue )
						console.error("UIManager:_MannWhitneyForTestrun : 2 mann whitney implementations give different results! ", results1, results2, wptData );
				}
				
				if( !errorOnU && Math.abs(results1.p - results2.p)  > 0.005 )//0.015 )
				{
					if( !allTheSameValue )
						console.error("UIManager:_MannWhitneyForTestrun : large error in p calc ", results1, results2, measurements, controlMeasurements, wptData );
				}
			}
			
			
			// from here on out, we assume results1 and results2 convey the same conclusions, and we can just proceed with results1 
			// relative improvement = 1 - median(A)/median(B)   if p < 0.005
			//						  0                         otherwise
			if( !results1.significantP )
			{
				results1.medianImprovement = 0; // not significally different, so no improvement or degradation 
				
				
				// we also calculate the reverse logic (p is significant is > 0.005, as originally described by Tom Bergan)
				var median = _CalculateMedian( measurements );
				results1.medianImprovementReverseLogic = 1 - (median / controlMedian);
				
				
				// note: just because medians differ largely, this doesn't mean this difference is necessarily significant
				// for example, when doing measurements on a verypoor network, the medians can be quite different because there is such a large variablity in the data (load times up to 50 seconds etc.)
				// see also http://www.graphpad.com/support/faqid/1327/
				// sanity check : if this is the case, the medians should be very similar as well?
				if( Math.abs(median - controlMedian) > 100 )
				{
					//console.warn("UIManager:_MannWhitneyForTestrun : results were not significat, but medians differ heavily! ", median, controlMedian, results1.p);
				}
			}
			else
			{
				// we need to calculate the median values 
				// we normally have 20 samples, so there is not 1 median value 
				// 2 options: a) pick the 10th OR 11th value consistently
				// 			  b) interpolate between the 10th and 11th value 
				// since our influxdb values interpolate (see the npm fast-stats package that is used by Sitespeed.io)
				
				var median = _CalculateMedian( measurements );
						
				// negative value means median is > controlMedian, so we have a SLOW DOWN 
				// positive value means median is > controlMedian, so we have SPEED UP 
				results1.medianImprovement = 1 - (median / controlMedian);
				
				//console.log( " result : " + results1.improvement, median, controlMedian, (median/controlMedian) );
				
				// sanity check to see if calculated median is the same as what we have in our influxdb 
				// this CAN happen if we had an "undefined" value in our data
				// we throw away these values before calculating, so we can have 19 instead of 20 samples in the case of 1 undefined value 
				// but it could be the influxdb values did keep undefined in the sample count, so stil lhad 20 samples, so interpolated between 10th and 11th value 
				// in our tests, we only saw this for 1 datapoint though! 
				if( metricName == value[ value[0].indexOf("metric") ] )
				{
					if( median != value[ value[0].indexOf("median") ])
					{
						var sortedMeasurements = measurements.slice();
						sortedMeasurements.sort(function(a,b){ return a - b;});
						
						if( self.finegrainedLogging )
						{
							console.warn("UIManager:_MannWhitneyForTestrun : median calculated is not the same as median from influxdb! ", median, value[ value[0].indexOf("median") ], sortedMeasurements, value);
						}
					}
				}
				
				
				// we also calculate the reverse logic (p is significant is > 0.005, as originally described by Tom Bergan)
				results1.medianImprovementReverseLogic = 0;
			}
			
			
			results1.measurements = measurements; // send along the extracted WPT values for easy access later (to generate the CDFs)
			results1.influxdbValue = value;
			output[ subcaseName ] = results1;//[ results1, results2 ];//mannWhitneyResults;
			
		//}
	}
	
	return output;
};