
function WPTDataCache(dataRoot) 
{
  this.wptData = {};  
};

WPTDataCache.prototype.LoadFromStorage = function(callback)
{
	var self = this;
	ldb.get("wptDataCache", function(result)
	{
		var dataString = result;
	
		if( dataString && dataString !== undefined && dataString != "undefined" && dataString.length > 0 )
		{
			console.log("WPTDataCache:GetStoredData : fetch success, current store size : " + dataString.length );
			self.wptData = JSON.parse(dataString).data;
			
			console.log("WPTDataCache:GetStoredData success : " + Object.keys(self.wptData).length, self.wptData);
			callback(undefined);
		}
		else 
		{
			self.wptData = {};
			console.log("WPTDataCache:GetStoredData no data found... starting anew ");
			callback(undefined);
		}
	});
};

WPTDataCache.prototype.GetLocalDataFor = function(id)
{
	return this.wptData[id];
};

WPTDataCache.prototype.FetchRemoteDataFor = function(id, callback)
{
	var self = this;
	
	var url = "LOCAL_WebpagetestInstance_URL";
	url += id;
	url += "&f=json&requests=0";
	
	console.log("WPTDataCache:FetchRemoteDataFor : " + url ); 

	$.get(url, function(result)
	{
		callback(result); 
	});
};

// utility functions to wrap around IndexedDB 
// localStorage has a limit of 5MB, which is way too little for this 
/*
WPTDataCache.prototype.GetStoredData = function()
{
	var dataString = ldb.get("wptDataCache");//localStorage.getItem("wptDataCache");
	
	console.log("WPTDataCache:GetStoredData ", dataString);
	
	if( dataString && dataString.length > 0 )
	{
		return JSON.parse(dataString).data;
	}
	else 
		return {};
};
*/

WPTDataCache.prototype.DeleteStoredData = function() 
{
	ldb.set("wptDataCache", undefined);
	//localStorage.removeItem("wptDataCache");
};

WPTDataCache.prototype.PersistLocalData = function()
{
	console.log("WPTDataCache:PersistLocalData ", this.wptData);
	ldb.set("wptDataCache", JSON.stringify({ data : this.wptData}) );
};

WPTDataCache.prototype.AddToLocalData = function( identifier, data )
{	
	this.wptData[identifier] = data;
};
